<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

  <xsl:param name="status"/>

  <!-- Add or process status elements inside status elements. -->

  <xsl:template match="candidate">
    <!-- Copy the element and its contents. -->
    <xsl:copy>
      <xsl:apply-templates select="@*"/>
      <identity>
        <xsl:apply-templates select="identity/@*"/>
      </identity>
      <!-- Look for a status element. -->
      <xsl:call-template name="status"/>
      <skills>
        <xsl:apply-templates select="skills/*"/>
      </skills>
      <qualifications>
        <xsl:apply-templates select="qualifications/*"/>
      </qualifications>
      <experience>
        <xsl:apply-templates select="experience/*"/>
      </experience>
    </xsl:copy>
  </xsl:template>

  <!-- Investigate status elements. -->

  <xsl:template name="status">
    <!-- Make the element. -->
    <status>
      <xsl:apply-templates select="status/@*"/>
      <xsl:call-template name="status-enum"/>
    </status>
  </xsl:template>

  <!-- Add to status elements the range of acceptable values. -->

  <xsl:template name="status-enum">
    <!-- Find all values in the range and add them. -->
    <xsl:for-each select="$status/status/status-enum">
      <xsl:copy>
        <xsl:apply-templates select="@*"/>
      </xsl:copy>
    </xsl:for-each>
  </xsl:template>

  <!-- Replicate unknown elements. -->

  <xsl:template match="@*|*|node()">
    <xsl:copy>
      <xsl:apply-templates select="@*|*|node()"/>
    </xsl:copy>
  </xsl:template>

</xsl:stylesheet>
